#include	<avr/io.h>
#include	<avr/interrupt.h>
#include	<util/delay.h>
#include	"spi_adc.h"

extern	volatile unsigned	int	my_adc, remote_adc;

volatile int	spi_mode = MASTER;
volatile enum	{ START=0x30, HIGH_BYTE, LOW_BYTE } state = START;

void	SPI_init(void);

ISR(SPI_STC_vect)
{	/*  忡   Ϸ  */
	if( SPCR & 1<<MSTR ){
		switch(state){
		case START:		      // START ۽ Ϸ
				SPDR = state = HIGH_BYTE;	 // HIGH_BYTE û ۽
				break;

		case HIGH_BYTE:			// HIGH_BYTE  Ϸ
				remote_adc = SPDR<<8;
				SPDR = state = LOW_BYTE;	// LOW_BYTE û ۽
				break;

		case LOW_BYTE:			// LOW_BYTE  Ϸ
				remote_adc |= (unsigned char)SPDR;
				SPI_init();	//    · ʱȭ
				break;
		}

	/* ̺ 忡  ۽ Ϸ  */
	}else if(spi_mode == SLAVE){
		switch(SPDR){
		case START:
			SPDR = my_adc>>8;			//  Ʈ غ
			break;

		case HIGH_BYTE:
			SPDR = (unsigned char)my_adc;	//  Ʈ غ
			break;

		case LOW_BYTE:
			break;					//  Ʈ  Ϸ
		
		default:;
		}

	/*   -> ̺   : /SS ȣ LOW  */
	}else if(spi_mode == MASTER){
		spi_mode = SLAVE;
		DDRB = (DDRB | 1<<MISO) & ~(1<<MOSI);   // ̺ Ʈ  
	}
}

void	SPI_init(void)
{	// SPI, , LSB , SPI ͷƮ, SCK HIGH,  ø, 1/64 
	SPCR |= 1<<SPE | 1<<DORD | 1<<MSTR | 1<<SPIE | 1<<CPOL | 1<<CPHA | 1<<SPR1;
	PORTB |= 1<<SS | 1<<SCK;					   // SS, SCK Ǯ
	DDRB &= ~(1<<SS | 1<<SCK | 1<<MOSI | 1<<MISO);   //    
}

/* Ͱ /SS SCK ȣ ְϿ SPI  */
void	master_get_slave_ADC(void)
{
	spi_mode = MASTER;	//   
	SPCR |= 1<<MSTR;
	PORTB &= ~(1<<SS);	// /SS ȣ ̸ LOW غ
	DDRB = (DDRB | 1<<SS | 1<<SCK | 1<<MOSI) & ~(1<<MISO); //   
	SPDR = state = START;	// START 
}
